/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.util.Properties;
import java.util.logging.Logger;

/**
 * ファイルに関連するユーティリティ・クラス。
 * @author T.Nishiki
 */
public class FileUtil {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。<br>
	 * ログ出力オブジェクトを取得します。
	 */
	static {
		_logger = LoggerUtil.getLogger(FileUtil.class);
	}

	/**
	 * ファイルをコピーします。<br>
	 * @param fromFile コピー元のファイル。
	 * @param toFile コピー先ファイル。
	 * @throws IOException コピーに失敗した場合。
	 */
	public static void copyFile(File fromFile, File toFile)
			throws IOException {
		// メソッド開始タグ
		String logMessge = null;
		if (LoggerUtil.isLoggableMethod(_logger)) {
			logMessge = "copyFile("
				+ "File<" + fromFile.getAbsolutePath() + ">"
				+ ", File<" + toFile.getAbsolutePath() + ">)";
			LoggerUtil.methodHead(_logger, logMessge);
		}

		// 以下コピー処理
		BufferedInputStream inputStream = null;
		BufferedOutputStream outputStream = null;
		boolean successFlag = false;
		try {
			File toDir = toFile.getParentFile();
			if (toDir.exists() == false) {
				toDir.mkdirs();
			}
			// 出力先フォルダ作成
			toFile.getParentFile().mkdirs();
			// ストリームオープン
			inputStream = new BufferedInputStream(
				new FileInputStream(fromFile));
			outputStream = new BufferedOutputStream(
				new FileOutputStream(toFile));
			// コピー処理
			byte[] buffer = new byte[1024 * 10];
			while (true) {
				int length = inputStream.read(buffer);
				if (length <= 0) {
					break;
				}
				outputStream.write(buffer, 0, length);
			}
			successFlag = true;
		}
		catch (IOException e) {
			LoggerUtil.throwable(_logger, e);
			throw e;
		}
		finally {
			IOException e = null;
			// 入力ストリームのクローズ
			try {
				close(inputStream, successFlag);
			}
			// 例外が発生してもスローは後にする。
			catch (IOException ie) {
				e = ie;
			}
			// 出力ストリームのクローズ
			close(outputStream, successFlag);
			// 入力ストリームで例外発生していればスロー。
			if (e != null) {
				throw e;
			}
		}
		// メソッド終了タグ
		if (LoggerUtil.isLoggableMethod(_logger)) {
			LoggerUtil.methodTail(_logger, logMessge);
		}
	}

	/**
	 * 指定されたファイルまたはディレクトリを削除します。<br>
	 * ディレクトリの場合、先に子ファイル／ディレクトリを削除します。
	 * @param file 削除対象のディレクトリ。
	 * @throws IOException 削除に失敗した場合。
	 */
	public static void delete(File file) throws IOException {
		// メソッド開始タグ
		LoggerUtil.methodHead(_logger, "delete(" + file + ")");

		// ディレクトリの場合、先に子供を削除します。
		if (file.isDirectory()) {
			File[] children = file.listFiles();
			for (int i = 0; i < children.length; i++) {
				delete(children[i]);
			}
		}
		boolean result = file.delete();
		if (result == false) {
			throw new IOException(
				"Cannot delete File[" + file + "]");
		}
		// メソッド終了タグ
		LoggerUtil.methodTail(_logger, "delete(" + file + ")");
	}

	/**
	 * 入力ストリームを閉じます。<br>
	 * 指定された入力ストリームのクローズを試みます。
	 * その際、例外がスローされた場合、引数の指定により、
	 * このメソッドから例外をスローするか否か判断します。<br>
	 * @param stream クローズを試みる入力ストリーム。
	 * @param throwFlag クローズで例外が発生した場合、このメソッドが例外を
	 *         スローする場合はtrueを、スローさせない場合はfalseを指定します。
	 * @throws IOException クローズ中に例外が発生し、かつ、
	 *          throwFlagがtrueの場合。
	 */
	public static void close(InputStream stream, boolean throwFlag)
		throws IOException {

		if (stream != null) {
			try {
				stream.close();
			}
			// 例外が発生した場合、引数の指定に従い、スローするか判断します。
			catch (IOException e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					throw e;
				}
			}
		}
	}

	/**
	 * 出力ストリームを閉じます。<br>
	 * 指定された出力ストリームのクローズを試みます。
	 * その際、例外がスローされた場合、引数の指定により、
	 * このメソッドから例外をスローするか否か判断します。<br>
	 * @param stream クローズを試みる出力ストリーム。
	 * @param throwFlag クローズで例外が発生した場合、このメソッドが例外を
	 *         スローする場合はtrueを、スローさせない場合はfalseを指定します。
	 * @throws IOException クローズ中に例外が発生し、かつ、
	 *          throwFlagがtrueの場合。
	 */
	public static void close(OutputStream stream, boolean throwFlag)
		throws IOException {

		if (stream != null) {
			try {
				stream.close();
			}
			// 例外が発生した場合、引数の指定に従い、スローするか判断します。
			catch (IOException e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					throw e;
				}
			}
		}
	}

	/**
	 * 文字入力ストリームを閉じます。<br>
	 * 指定された文字入力ストリームのクローズを試みます。
	 * その際、例外がスローされた場合、引数の指定により、
	 * このメソッドから例外をスローするか否か判断します。<br>
	 * @param reader クローズを試みる文字入力ストリーム。
	 * @param throwFlag クローズで例外が発生した場合、このメソッドが例外を
	 *         スローする場合はtrueを、スローさせない場合はfalseを指定します。
	 * @throws IOException クローズ中に例外が発生し、かつ、
	 *          throwFlagがtrueの場合。
	 */
	public static void close(Reader reader, boolean throwFlag)
		throws IOException {

		if (reader != null) {
			try {
				reader.close();
			}
			// 例外が発生した場合、引数の指定に従い、スローするか判断します。
			catch (IOException e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					throw e;
				}
			}
		}
	}

	/**
	 * 文字出力ストリームを閉じます。<br>
	 * 指定された文字出力ストリームのクローズを試みます。
	 * その際、例外がスローされた場合、引数の指定により、
	 * このメソッドから例外をスローするか否か判断します。<br>
	 * @param writer クローズを試みる文字出力ストリーム。
	 * @param throwFlag クローズで例外が発生した場合、このメソッドが例外を
	 *         スローする場合はtrueを、スローさせない場合はfalseを指定します。
	 * @throws IOException クローズ中に例外が発生し、かつ、
	 *          throwFlagがtrueの場合。
	 */
	public static void close(Writer writer, boolean throwFlag)
		throws IOException {

		if (writer != null) {
			try {
				writer.close();
			}
			// 例外が発生した場合、引数の指定に従い、スローするか判断します。
			catch (IOException e) {
				LoggerUtil.throwable(_logger, e);
				if (throwFlag) {
					throw e;
				}
			}
		}
	}

	/**
	 * 指定したファイルをプロパティとして読み込みます。
	 * @param file プロパティとして読み込むファイル。
	 * @param throwFileNotFound fileで指定したファイルを読み込もうとして、
	 *         FileNotFoundExceptionがスローされたとき、
	 *         例外をスローする場合はtrue、
	 *         スローせず空のPropertiesを戻す場合はfalseを渡します。
	 * @return fileから生成されたプロパティ。
	 *          ファイルが存在せず、かつ、throwFileNotFoundがfalseの場合、
	 *          空のプロパティを戻します。
	 * @throws IOException 読込に失敗した場合。
	 */
	public static Properties loadAsProperties(
			File file, boolean throwFileNotFound)
			throws IOException {
		// メソッド開始タグ
		LoggerUtil.methodHead(_logger,
			"loadAsProperties(" + file + "," + throwFileNotFound + ")");
		// このメソッドの戻り値
		Properties properties = null;
		// ファイルからの読み込み用
		InputStream stream = null;
		// 成功フラグ
		boolean successFlag = false;
		try {
			properties = new Properties();
			// ファイルから入力ストリームを取得
			try {
				stream = new BufferedInputStream(new FileInputStream(file));
				// プロパティとしてロード
				properties.load(stream);
			}
			catch (FileNotFoundException e) {
				// ファイルが見つからないとき、引数の指定によりスローを判断
				if (throwFileNotFound) {
					throw e;
				}
			}
			// tryブロック終端まで達すれば、成功。
			successFlag = true;
		}
		finally {
			close(stream, successFlag);
		}
		// メソッド終了タグ
		LoggerUtil.methodTail(_logger,
			"loadAsProperties(" + file + "," + throwFileNotFound + ")",
			properties);
		return properties;
	}

	/**
	 * 指定したファイルをプロパティとして読み込みます。
	 * @param file プロパティとして読み込むファイル。
	 * @return fileから生成されたプロパティを戻します。
	 *          ファイルが存在しない場合は、空のプロパティを戻します。
	 * @throws IOException 読込に失敗した場合。
	 */
	public static Properties loadAsProperties(File file)
			throws IOException {
		// メソッド開始タグ
		LoggerUtil.methodHead(_logger, "loadAsProperties(" + file + ")");
		// このメソッドの戻り値
		Properties properties = null;
			properties = FileUtil.loadAsProperties(file, false);
		// メソッド終了タグ
		LoggerUtil.methodTail(_logger, "loadAsProperties(" + file + ")");
		return properties;
	}
}
